



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>iBatis调用存储过程以及MySQL创建存储过程</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">iBatis调用存储过程以及MySQL创建存储过程</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 07:14:58 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p><strong>首先是MySQL中创建存储过程的SQL</strong></p>
<pre class="prettyprint linenums">-- 列出全部的存储过程<br />
SHOW PROCEDURE STATUS;

-- 查看一个已存在的存储过程的创建语句,假设此存储过程不存在,会提示SQL错误（1305）：PROCEDURE pro_init does not exist<br />
SHOW CREATE PROCEDURE pro_init;

-- 创建存储过程<br />
DROP PROCEDURE IF EXISTS pro_init; -- 删除一个已存在的存储过程<br />
DELIMITER //                       -- 声明当前MySQL分隔符为//<br />
CREATE PROCEDURE pro_init(username VARCHAR(60), OUT userId INT)<br />
BEGIN<br />
	SELECT user_id INTO userId FROM user_info ui WHERE ui.username=username;<br />
	IF userId IS NULL OR userId=&#039;&#039; THEN<br />
		SELECT 0 INTO userId;<br />
	ELSE<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;巴西&#039;, &#039;俄罗斯&#039;, NULL, now());<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;法国&#039;, &#039;西班牙&#039;, NULL, now());<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;荷兰&#039;, &#039;英格兰&#039;, NULL, now());<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;智利&#039;, &#039;意大利&#039;, NULL, now());<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;伊朗&#039;, &#039;葡萄牙&#039;, NULL, now());<br />
		INSERT INTO t_worldcup_team(userId, teamAA, teamBB, updateTime, createTime)<br />
		VALUES(userId, &#039;希腊&#039;, &#039;阿根廷&#039;, NULL, now());<br />
	END IF;<br />
END<br />
//                                 -- 分隔符,表示此SQL语句结束

-- 调用存储过程<br />
CALL pro_init(&#039;hongyu&#039;, @userId);<br />
SELECT @userId;</pre>
<p><strong>以下是iBatis配置文件的写法</strong></p>
<pre class="prettyprint linenums">&lt;parameterMap id=&quot;pro_init_Map&quot; class=&quot;java.util.Map&quot;&gt;<br />
	&lt;parameter property=&quot;username&quot; javaType=&quot;java.lang.String&quot; jdbcType=&quot;VARCHAR&quot; mode=&quot;IN&quot;/&gt;<br />
	&lt;parameter property=&quot;userId&quot; javaType=&quot;java.lang.Integer&quot; jdbcType=&quot;INT&quot; mode=&quot;OUT&quot;/&gt;<br />
&lt;/parameterMap&gt;<br />
&lt;procedure id=&quot;pro_init&quot; parameterMap=&quot;pro_init_Map&quot;&gt;<br />
	{call pro_init(?, ?)}<br />
&lt;/procedure&gt;</pre>
<p><strong>最后是Java调用类的写法</strong></p>
<pre class="prettyprint linenums">public int teamInit(String username) {<br />
	int userId = 0;<br />
	Map&lt;String, Object&gt; paramMap = new HashMap&lt;String, Object&gt;();<br />
	paramMap.put(&quot;username&quot;, username);<br />
	paramMap.put(&quot;userId&quot;, userId);<br />
	this.getSqlMapClientTemplate().queryForObject(&quot;worldcup_guess.pro_init&quot;, paramMap);<br />
	return (Integer)paramMap.get(&quot;userId&quot;);<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvvkexq.html">Entity Framework关于SQL注入安全问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q22503q.html">在阿里云ECS上搭建LEMP环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxjpj09.html">【BZOJ1051】1051&colon; &lbrack;HAOI2006&rsqb;受欢迎的牛 tarjan求强连通分量&plus;缩点</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd2vj09.html">ora-01031&colon;insufficient privileges解决方法 - 转</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z0evdq.html">新技能，利用Reflector来修改dll引用</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2o0go9.html">《WCF服务编程第三版》知识点摘录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e16vjx9.html">结合使用 Oracle Database 11g 和 Python</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmd6l69.html">sourceInsight的技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxklmmj8.html">CodeForces 500 A&period; New Year Transportation</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mepl1rq.html">w7如何安装配置多个tomcat</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyrkwx9.html">C&num;PreviewKeyDown  与KeyDown 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgw22e8.html">理解纯CSS画三角形</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z1do09.html">Node&period;js Buffer&lpar;缓冲区&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp2jdxq.html">sqlserver 2014使用时有Cannot find one or more components</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5zeo7q.html">DevExpress ASP&period;NET Core Controls 2019发展蓝图（No&period;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvj7xy8.html">arduino 引脚作为输入时的不稳定 解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rnzl4eq.html">OpenGL学习（2）&mdash;&mdash;绘制三角形（补）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1jev19.html">吴恩达-coursera-机器学习-week6</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7eek6g9.html">GCT之数学公式（几何部分）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppm1ly9.html">github中的一个快捷键</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7m0g5xq.html">c&plus;&plus;  头文件 及 sort</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3kx0q.html">函数buf&lowbar;LRU&lowbar;get&lowbar;free&lowbar;block</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7m0dpeq.html">bzoj1789 AHOI 维护数列（线段树）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnz6kj8.html">PHP简单下载</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y37kjq.html">以CTE表达式实现MSSQL的字符串分割函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1rrv59.html">RMAN数据库异机迁移</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4y3wy0q.html">（Java）利用ListIterator（iterator 重复器&sol;迭代器的子接口） 操作ArrayList</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnrze6q.html">error MSB3027&colon; Could not copy &amp;quot&semi;xxx&period;dll&amp;quot&semi; to &amp;quot&semi;xxx&period;dll&amp;quot&semi;&period; Exceeded retry count of 10&period; Failed&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0dg5gq.html">转载--PHP json&lowbar;encode&lpar;&rpar; 和json&lowbar;decode&lpar;&rpar;函数介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ozkw39.html">Zabbix探索：Discovery任务、进程以及占用率</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
